/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TBPR                                                     */
/* Tabela : TABEPREC                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 29/10/2005  Renata Diniz Viana                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TBPR' and
            type = 'TR'              and
            u.uid = o.uid            and
            u.name = USER)
   DROP TRIGGER DTULTATU_TBPR
GO

CREATE TRIGGER DTULTATU_TBPR ON TABEPREC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TABEPREC', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDTABEPREC='+CDTABEPREC+';',
                CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TABEPREC
      SET DTULTATUTBPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(TABEPREC.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(TABEPREC.CDTABEPREC,0) = ISNULL(INSERTED.CDTABEPREC,0));
   END;

END;
GO

UPDATE TABEPREC SET DTULTATUTBPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUTBPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUTBPR' and
            type = 'D')
   ALTER TABLE TABEPREC DROP CONSTRAINT DEFAULT_DTULTATUTBPR
GO

ALTER TABLE TABEPREC ADD CONSTRAINT DEFAULT_DTULTATUTBPR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUTBPR
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TBPR','5.07.005';
GO

